#!/bin/bash
dialog --title "PAT WINLINK (packet) - ALPHA" --msgbox "\nMake sure your rig is connected to the Quadra and powered on before continuing" 7 80
clear
# get pat-gensio, flrig and hamlib
sudo apt -y install libhamlib4 libhamlib-utils flrig
mkdir -p ~/.config/pat
if [ ! -f ~/.config/pat/config.json.template ]; then
  cp config.json ~/.config/pat/config.json.template
fi
cp ~/.config/pat/config.json.template ~/.config/pat/config.json
sudo mv pat /usr/bin/pat
if [ -f ~/.asoundrc ]; then
  mv ~/.asoundrc ~/.asoundrc.save
fi
cp ~/asoundrc ~/.asoundrc
sudo mv ~/ardopc /usr/local/bin
# set user info in pat config file
dialog --backtitle "PAT Winlink Setup" --title "PAT Winlink setup" \
--form "\nEnter your:" 30 60 10 \
"Callsign:" 1 1 "" 1 25 25 30  \
"Winlink Password:" 3 1 "" 3 25 25 30  \
"gridsquare:" 5 1 "" 5 25 25 30 \
"Use up/down arrows to move between fileds" 7 1 "" 7 0 0 0 \
"tab to reach buttons" 8 1 "" 8 0 0 0 \
> /tmp/out.tmp \
2>&1 >/dev/tty
# Start retrieving each line from temp file 1 by one with sed and declare variables as inputs
callsign=`sed -n 1p /tmp/out.tmp`
pat_pw=`sed -n 2p /tmp/out.tmp`
gridsquare=`sed -n 3p /tmp/out.tmp`
# remove temporary file created
rm -f /tmp/out.tmp
#Write the result to config.json
sed -i "s/MYCALL/$callsign/" ~/.config/pat/config.json
sed -i "s/MYPASS/$pat_pw/" ~/.config/pat/config.json
sed -i "s/MYGRID/$gridsquare/" ~/.config/pat/config.json
# get sound card info and write to config.json
line=$(aplay -l | grep USB)
card=$(echo "$line" | awk '{print $2}' | tr -d ':')
device=$(echo "$line" | awk '{print $8}' | tr -d ':')
sed -i "s/MYCARD/$card/" ~/.config/pat/config.json
sed -i "s/MYDEVICE/$device/" ~/.config/pat/config.json
flrig &
clear
dialog --infobox "Configure your rig in flrig under 'config'/'Setup'/'Transceiver' then close it to save the configuration.\n\nIf you need help, Google your rig model number & 'flrig'.  This will likely give you the configuration information you need.\n\nStart PAT in a terminal window with ./pat_wrap.sh" 10 80

